"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * Allow a fixed length function to be partially applied.
 * @param f Function you'd like to curry
 */
exports.curry = function (f) {
    return curriedN(f.length, f, []);
};
function curriedN(arity, f, previousArgs) {
    if (arity < 2) {
        return f;
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var concatArgs = previousArgs.concat(args);
        return concatArgs.length >= arity ? f.apply(void 0, tslib_1.__spread(concatArgs)) : curriedN(arity, f, concatArgs);
    };
}
//# sourceMappingURL=curry.js.map