"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var apply_1 = require("./apply");
/**
 * Reverse the first two arguments of a function
 * @param fn: (a -> b -> c)
 * @returns (b -> a -> c)
 */
exports.flip = function (fn) {
    return (function (a, b) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return apply_1.apply(tslib_1.__spread([b, a], args), fn);
    });
};
//# sourceMappingURL=flip.js.map