"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var common_1 = require("@typed/common");
/**
 * Memoize a function
 * @param f Function to memoize
 */
exports.memoize = function (f) {
    var cache = new Map();
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var key = args.reduce(function (x, y) { return x + common_1.toString(y); }, '');
        if (cache.has(key)) {
            return cache.get(key);
        }
        var result = f.apply(void 0, tslib_1.__spread(args));
        if (typeof result === 'function') {
            result = exports.memoize(result);
        }
        cache.set(key, result);
        return result;
    };
};
//# sourceMappingURL=memoize.js.map