"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Left-to-right composition for exactly two function */
exports.pipe2 = function (f, g) { return function (x) { return g(f(x)); }; };
/**
 * Generic Left-to-right composition
 */
exports.pipe = (function () {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return fns.length > 1 ? fns.slice(1).reduce(exports.pipe2, fns[0]) : fns[0];
});
//# sourceMappingURL=pipe.js.map