"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Convert a function like (a -> b -> c -> d) into ((a, b, c) -> d)
 * @param fn :: Function to uncurry
 * @returns Function that accepts all arguments at once.
 */
function uncurry(f) {
    if (typeof f !== 'function' || f.length === 0) {
        return f;
    }
    // tslint:disable-next-line:only-arrow-functions
    return function () {
        var r = f;
        // tslint:disable-next-line:prefer-for-of
        for (var i = 0; i < arguments.length; i++) {
            r = r(arguments[i]);
        }
        return uncurry(r);
    };
}
exports.uncurry = uncurry;
//# sourceMappingURL=uncurry.js.map