import * as tslib_1 from "tslib";
import { toString } from '@typed/common';
/**
 * Memoize a function
 * @param f Function to memoize
 */
export var memoize = function (f) {
    var cache = new Map();
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var key = args.reduce(function (x, y) { return x + toString(y); }, '');
        if (cache.has(key)) {
            return cache.get(key);
        }
        var result = f.apply(void 0, tslib_1.__spread(args));
        if (typeof result === 'function') {
            result = memoize(result);
        }
        cache.set(key, result);
        return result;
    };
};
//# sourceMappingURL=memoize.js.map