import * as tslib_1 from "tslib";
import { curry } from './curry';
var NOTHING = Symbol('nothing');
/**
 * Perform an operation with the previous value returned
 * @param withFn :: (a -> *)
 * @param fn: (...* -> a)
 * @returns (...* -> a)
 */
export var withPrevious = curry(function withPrevious(withFn, fn) {
    var _a;
    var previous = (_a = {}, _a[NOTHING] = true, _a);
    return function () {
        var _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!isNothing(previous)) {
            withFn(previous.value);
        }
        var value = fn.apply(void 0, tslib_1.__spread(args));
        previous = (_a = {}, _a[NOTHING] = false, _a.value = value, _a);
        return value;
    };
});
function isNothing(maybe) {
    return maybe[NOTHING];
}
//# sourceMappingURL=withPrevious.js.map